Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Attributes | List of all members
BackupPlugin Class Reference
Inheritance diagram for BackupPlugin:

## Public Slots
QString | version ()

## Signals
void | updateView ()
void | updatedObject (int _identifier, const UpdateType &_type)
void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | getMenubarMenu (QString _name, QMenu *&_menu, bool _create)
void | undo (int _objectid)
void | undo ()
void | redo (int _objectid)
void | redo ()
void | aboutToRestore (int _objectid)
void | restored (int _objectid)
void | generateBackup (int _id, QString _name, UpdateType _type)
void | addToolbar (QToolBar *_toolbar)
void | getToolBar (QString _name, QToolBar *&_toolbar)
void | registerKey (int _key, Qt::KeyboardModifiers _modifiers, QString _description, bool _multiUse=false)
void | addContextMenuItem (QAction *_action, DataType _objectType, ContextMenuType _type)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from KeyInterface
virtual void | registerKey (int _key, Qt::KeyboardModifiers _modifiers, QString _description, bool _multiUse=false)
| Register a key-combination for your plugin. More...
Signals inherited from MenuInterface
virtual void | getMenubarMenu (QString _name, QMenu *&_menu, bool _create)
| Get a existing top level menu pointer or create a new one. More...
Signals inherited from BackupInterface
virtual void | aboutToRestore (int _objectid)
| Backup Plugin tells other Plugins that a restore will happen. More...
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This signal is emitted by a BackupPlugin and tells a TypePlugin to generate a backup. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from ToolbarInterface
virtual void | addToolbar (QToolBar *_toolbar)
| Adds a Toolbar to the main widget. More...
Signals inherited from LoadSaveInterface
virtual void | save (int _id, QString _filename)
| Save object to a file. More...
virtual void | load (QString _filename, DataType _type, int &_id)
| Load object from file with a specific DataType. More...
Signals inherited from ContextMenuInterface
virtual void | addContextMenuItem (QAction *_action, ContextMenuType _type)
| Add an entry for a context Menu. More...

## Public Member Functions
void | createBackup (int _objectId, QString _name, UpdateType _type=UPDATE_ALL)
| Tell Backup Plugin to create a backup. More...
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...

## Private Slots
void | initializePlugin ()
void | pluginsInitialized ()
void | slotAllCleared ()
void | slotKeyEvent (QKeyEvent *_event)
void | objectDeleted (int _objectid)
void | slotCreateBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
void | slotCreateBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
void | slotUndo (int _objectid)
void | slotRedo (int _objectid)
void | slotUndo ()
void | slotRedo ()
void | slotUpdateContextMenu (int _objectId)
bool | initializeOptionsWidget (QWidget *&_widget)
void | applyOptions ()
void | updateButtons ()
void | slotEnableDisableBackups ()
| Backups enabled or disabled checkbox.
void | slotObjectUndo ()
void | slotObjectRedo ()
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...
Private Slots inherited from KeyInterface
virtual void | slotKeyEvent (QKeyEvent *_event)
| Key Event from Main App. More...

## Private Attributes
GroupData | globalBackup_
QMenu * | backupMenu_
| The backup Menu.
QAction * | backupsEnabledAction_
QAction * | undoMenuAction_
QAction * | redoMenuAction_
QAction * | undoToolAction_
QAction * | redoToolAction_
QAction * | undoContextAction_
QAction * | redoContextAction_
QSpinBox * | maxBackupSpinBox_

## Additional Inherited Members
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from KeyInterface
virtual void | slotKeyReleaseEvent (QKeyEvent *_event)
| Key Release Event from Main App. More...
virtual | ~KeyInterface ()
| Destructor.
Private Member Functions inherited from MenuInterface
virtual | ~MenuInterface ()
| Destructor.
virtual void | addMenubarAction (QAction *_action, QString _name)
| Adds an action to the menubar. More...
virtual void | addMenubarActions (std::vector< QAction *> &_actions, QString _name)
| Add multiple actions to the menu bar. More...
Private Member Functions inherited from BackupInterface
virtual void | createBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
| Tell Backup Plugin to create a group backup. More...
virtual void | undo (int _objectid)
| Tell Backup Plugin to undo the last action of an object. More...
virtual void | redo (int _objectid)
| Tell Backup Plugin to redo the last action on an object. More...
virtual void | undo ()
| Tell Backup Plugin to undo the last action. More...
virtual void | redo ()
| Tell Backup Plugin to redo the last action. More...
virtual | ~BackupInterface ()
| Destructor.
virtual void | restored (int _objectid)
| Backup Plugin tells other Plugins that a restore has happened. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from ToolbarInterface
virtual | ~ToolbarInterface ()
| Destructor.
virtual void | removeToolbar (QToolBar *_toolbar)
| Remove a Toolbar from the main widget. More...
virtual void | getToolBar (QString _name, QToolBar *&_toolbar)
| Get a pointer to a Toolbar of the given name or 0 if it does not exist. More...
Private Member Functions inherited from LoadSaveInterface
virtual | ~LoadSaveInterface ()
| Destructor.
virtual void | addEmptyObject (DataType _type, int &_id)
virtual void | copyObject (int _oldId, int &_newId)
virtual void | emptyObjectAdded (int _id)
| DEPRECATED HERE (Moved to Type Interface)! Emit this signal if an empty object has been created. More...
virtual void | deleteObject (int _id)
| Delete an object This signal can be called from any thread. . More...
virtual void | deleteAllObjects ()
| Delete all Objects. More...
virtual void | getAllFileFilters (QStringList &_filters)
| Get all file filters that are registered. More...
Private Member Functions inherited from ContextMenuInterface
virtual | ~ContextMenuInterface ()
| Destructor.
virtual void | addContextMenuItem (QAction *_action, DataType _objectType, ContextMenuType _type)
| Add an entry for a context Menu. More...
virtual void | hideContextMenu ()
| hide the main context menu
Private Member Functions inherited from OptionsInterface
virtual | ~OptionsInterface ()
| Destructor.
virtual bool | initializeOptionsWidget (QWidget *&_widget)=0
| Initialize the Options Widget. More...
virtual void | applyOptions ()=0
| Apply changes to options. More...

## Detailed Description

Definition at line 61 of file BackupPlugin.hh.

## Member Function Documentation

## ◆ createBackup()

void BackupPlugin::createBackup | ( | int | _objectid,
|  | QString | _name,
|  | UpdateType | _type = `UPDATE_ALL`
| ) |  |
| virtual

Tell Backup Plugin to create a backup.

Plugins which supports backups can call this function if they want to create backups.
A Backup control Plugin will do the rest.

Parameters

  _objectid | Identifier of the object to create the backup
  _name | Name of the Backup, to show the user what can be recovered
  _type | The type of the backup (e.g. UPDATE_SELECTION)

Reimplemented from BackupInterface.

Definition at line 428 of file BackupPlugin.cc.

## ◆ description()

QString BackupPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 158 of file BackupPlugin.hh.

## ◆ name()

QString BackupPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 157 of file BackupPlugin.hh.

The documentation for this class was generated from the following files:

- Plugin-Backup/BackupPlugin.hh
- Plugin-Backup/BackupPlugin.cc